=== debian/changelog ===
paho.mqtt.cpp (1.6.0-1) unstable; urgency=medium

  * debian/watch: update to version 5
  * debian/control: update Standards-Version to 4.7.3 and remove redundant rules
  * New upstream version 1.6.0
  * debian/copyright: update copyright information

 -- Roman Ondráček <mail@romanondracek.cz>  Tue, 24 Feb 2026 18:35:50 +0100
