=== debian/control ===
Source: paho.mqtt.cpp
Section: libs
Maintainer: Roman Ondráček <mail@romanondracek.cz>
Build-Depends: debhelper-compat (= 13), cmake, doxygen, libcatch2-dev,
 libssl-dev, libpaho-mqtt-dev (>= 1.3.14)
Standards-Version: 4.7.3
Homepage: https://github.com/eclipse-paho/paho.mqtt.cpp/
Vcs-Browser: https://salsa.debian.org/ondracek/paho.mqtt.cpp
Vcs-Git: https://salsa.debian.org/ondracek/paho.mqtt.cpp.git

Package: libpaho-mqttpp3-1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Eclipse Paho MQTT C++ Client Library - shared libraries
 This library enables C++11 applications to connect to an MQTT broker,
 publish messages to the broker, and to subscribe to topics and receive
 published messages.
 .
 This package contains the shared library.

Package: libpaho-mqttpp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libpaho-mqttpp3-1 (= ${binary:Version}), ${misc:Depends}
Description: Eclipse Paho MQTT C++ Client Library - development files
 This library enables C++11 applications to connect to an MQTT broker,
 publish messages to the broker, and to subscribe to topics and receive
 published messages.
 .
 This package contains the development files.

Package: libpaho-mqttpp-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Eclipse Paho MQTT C++ Client Library - library documentation
 This library enables C++11 applications to connect to an MQTT broker,
 publish messages to the broker, and to subscribe to topics and receive
 published messages.
 .
 This package contains the doxygen generated HTML documentation for the
 libraries.
