=== debian/watch ===
Version: 5
Template: GitHub
Owner: eclipse-paho
Project: paho.mqtt.cpp
Pgp-mode: none
